#!/bin/sh


#-----begin confuration qfinger.sh ------
 
# FIN
#  -- mezerami odeleny popis fingeru pocitace
#
# pocitac.domena.cz:i=12;ilen=6;u=0;ulen=8
#  i sloupec idle
#  u sloupec uzivatele
#  ilen delka idle
#  ulen delka uzivatele
#
FIN="bbs.cvut.cz:i71 vechtrovna:i=31 zizalka:i=34 toaster:i=43
dema:i=44 jazzman:i=44
vitas:i=44 popelka.ms.mff.cuni.cz:i=43 ss1000:i=36 ksvi:u=5;i=80
barbora:u=5;i=80 koudy:i=37"

#
# PING mezerami oddeleny seznam stroju ktere chci jen pingat a ne fingerovat
#
PING="kma14 prometheus najdek"

#
# seznam sledovanych uzivatelu odleny '|'
#
USR="milan|mkop5320|gimli|Pietro|rsyk8145|koudy|pata|patu|zbynek|zbyna|demagog|jfon7134|petr|xofon|psko6590|davidek|opela|dope6434|vitas|vstr4611|pikomat|geo|hanika|sochor|lhac7151|roman|firtr9am|chocki|smudla|pkac4610"

#
# barvy
#
    
#cols: <esc>[01;Xm konec: <esc>[0m
# X 32 zelena; 31 cervena; 30 seda; 34 modra; 35 fialova; 36 blemodra; 37 svetle bila; 38 obyc seda 
# 33 zluta


# pocitac pinga (zelena)
UPCOL="[01;32m";

# pocitac nepinga (cervena)
DOWNCOL="[01;31m"

# barva zprava o stavu majitele stroje (podporuje toaster a jazzman) (zluta)
MSGCOL="[01;33m"


# ukoncovaci sekvence
ENDCOL="[0m"


# barva zprava o stavu majitele stroje (podporuje toaster a jazzman) (zluta)
COLCONFIG='upcol="'"$UPCOL"'";msgcol="'"$MSGCOL"'";endcol="'"$ENDCOL"'";'

#----------end of config -------------------------------


# puze pingni na $1 a vytiskni 
# * stroj v pripade ze pinga
# - stroj v pripade ze nepinga
function tryping(){
ARG=$1
LONGMACHINE=${ARG%%:*}
MACHINE=${LONGMACHINE%%.*}
FMACHINE=`printf '%8s' $MACHINE`
PARAMS=${ARG#*:}

ping -c 1 $LONGMACHINE  > /dev/null

if [ $? =  "0" ] ; then
  echo $UPCOL"* $FMACHINE"$ENDCOL;
else
  echo $DOWNCOL"- $FMACHINE"$ENDCOL;
fi
}

# finger na $1 
#
# + stroj
# - stroj
# @ stroj! user idle
# # stroj: mesg
#
#idle cislo
#

#unix finger $1 stroj

# vitas idle =29,5
# vitas idle =36,5
# $1 ve tvaru stroj:i=33;ilen=5;u=0;ulen=8


function tryfin(){
#format $1 je stroj:PARAMS
ARG=$1
LONGMACHINE=${ARG%%:*}
MACHINE=${LONGMACHINE%%.*}
FMACHINE=`printf '%8s' $MACHINE`
PARAMS=${ARG#*:}

#test jestli vubec bezi
ping -c 1 $LONGMACHINE  > /dev/null

if [ $? =  "0" ] ; then
  :
else
  #nebezi balime
  echo $DOWNCOL"- $FMACHINE"$ENDCOL;
  return 0;
fi

finger @$LONGMACHINE 2>&1|
awk '
BEGIN{
  #defaultni sloupce uzivatele a 
  u=0;ulen=8;i=26;ilen=6;
  #predefiny
  '$PARAMS';
  #barvicky
  '$COLCONFIG';
  #pokud je stroj refusuje finger, zmeni se na statchar na !
  statchar = "+"
}

#zacatek uzivatelu. do ted to byly jen kecy
/^User Id|^Username|^Login|^Nobody/{users=1;next}

# novelovsky fingerd ma pod Con radek "----" coz je nutno vynechat
/^Con/{novell=1;users=1;next}

#rake minusu znamena mesg o stavu majitele (a taky konec uzivatelu)
/^----------/{if(users&&!novell&&mesg!=-1){mesg=1;users=0};next;}

#zpracovani mesg
mesg==1&&!/^Debian GNU/{print msgcol"# '"$FMACHINE"': "$0 endcol;mesg=-1;}

#zpracovani uzivatelu, 
users>0{
   #vykousnout sloupec s iddle; hodint 0 jestli je tam tma: uzrat mezery
   iddle= substr($0, i , ilen);iddle= iddle~/^ *$/?"     0":iddle;sub("^ *","", iddle)

   #vykousnou uzivatele, zmensin pismenka
   usr= substr($0, u, ulen);usr=tolower(usr)
  
   #neni mezi prateli, kasli na nej
   if(usr!~"'"$USR"'"){next}

   #hura
   print "@ '"$FMACHINE"'! "usr" "iddle
   next
}
/^finger: connect: Connection refused/{ statchar = "!"; }

END{
   print upcol statchar " '"$FMACHINE"'" endcol
}

' |
awk '
# zpracovani vicekrat nalogovaneho uzivatele do jednoho radku
$1=="@"{
   # kdyz prijde novy pridej cely radek, jinak jen idle
   if(users[$3]==""){users[$3]=$0}else{users[$3]=users[$3]" "$4}
   next
}

#ostatni radky tistni jak lezi a bezi
{print}

#nakonec vytiskni vsechny uzivatele
END{
  for ( i in users ) {
    idllen = split(users[i], idl)
    printf "%s", substr(users[i],0,20)
    delete idl[1]; delete idl[2]; delete idl[3]
    idllen -= 3

    for (; idllen--;) {
      min = ":"
      for(j in idl) {
        if (min > idl[j]) {min=idl[j]; minj = j}
      }
      printf " %s", idl[minj]
      delete idl[minj]
    }
    printf "\n"
  }
}
'
}

#main()

#vsechny stroje pro fingerovani
for i in $FIN ; do
  tryfin $i &
done

#vsechny stroje pro pingani
for i in $PING ; do 
  tryping $i &
done

wait

